<template>
    <div class="subscriptions">
        <span v-if="noData">No subscriptions</span>
        <el-checkbox-group v-else v-model="checked">
            <el-checkbox v-for="(state, name) in data" :disabled="isOptionDisabled(name)" :key="name" :label="name" border></el-checkbox>
        </el-checkbox-group>
    </div>
</template>

<script>
import { checkIdentical } from '@bloomio/spa-admin-common/utils';
import { mapState } from 'vuex';

export default {
    props: {
        /** component id */
        id: {
            type: String,
            required: false,
            default: 'subscriptions',
        },
        /** checkbox statuses or empty string */
        data: {
            type: [Object, String],
            required: true,
        },
    },
    watch: {
        checked() {
            this.updateStoreParams();
        },
        data() {
            this.discardChanges();
            this.updateStoreParams();
        },
    },
    created() {
        this.restoreChanges();
    },
    data() {
        return {
            checked: [],
        };
    },
    computed: {
        isDisabled: vm => !vm.$store.getters.isEditable(vm.id),
        isOptionDisabled: vm => id => vm.isDisabled || !vm.data[id],
        initialChecked: vm => Object.keys(vm.data).reduce((acc, key) => {
            if (vm.data[key]) {
                acc.push(key);
            }
            return acc;
        }, []),
        noData: vm => !vm.data || !Object.keys(vm.data).length,
        ...mapState({
            savedData: state => state.editUser.subscriptions,
        }),
    },
    methods: {
        /**
         * Generate object with checkbox statuses
         * @param {Array} checkList - checked options
         */
        serverFormat(checkList) {
            Object.keys(this.data).forEach((key) => {
                if (checkList.indexOf(key) > -1) {
                    this.data[key] = true;
                } else {
                    this.data[key] = false;
                }
            });
        },
        /**
         * Reset the current checked options to the server ones
         */
        discardChanges() {
            this.checked = [...this.initialChecked];
        },
        /**
         * Restore checked options from vuex store (need after forced relogin)
         */
        restoreChanges() {
            this.checked = this.savedData.checked ? [...this.savedData.checked] : [...this.initialChecked];
        },
        /**
         * Update vuex store subscription params
         */
        updateStoreParams() {
            const changeStatus = !checkIdentical(this.checked, this.initialChecked);
            this.$emit('update', changeStatus);
            this.$store.commit('setSubscriptions', { checked: this.checked, status: changeStatus });
        },
    },
};
</script>

<style lang="stylus" scoped>
.subscriptions
    padding 1rem

/** Fixes for nested Element UI styles */
>>> .el-checkbox-group
    display flex
    flex-wrap wrap

>>> .is-bordered
    margin-right: 2rem
    margin-bottom: 1rem
    margin-left: 0 !important

</style>
